// knighty5_2 25/08/16

// a) Julia add [0] [1] [2]
// b) Csize [3] [4] [5] 
// c) subtraction of z has a Zscale [6] [7] [8]
// d) if (i >= BOX_FOLD && i < BOX_STOP)  [9] [10], no boxfold when [10] = 0
// e) clamp [11] = 0, then clamp (normal mode), else other way
// f) pseudo kleinina iterations [12]
// g) pseudo kleinian radius R2  [13]
// h) DE add (tweak) [14]
// i) scale mbox tab
// j) rotation mbox tab
// k) box fold limit & value mbox tab

for(int i=0;i<Iters;i++)
{
      
if (i >= BOX_FOLD && i < BOX_STOP) 
	{
	int3 cond1, cond2;	
	cond1 = isgreater(z, foldingLimit);
	cond2 = isless(z, -foldingLimit);
	z = select(z,  foldingValue - z, cond1);
	z = select(z,  -foldingValue - z, cond2); 
	} 	
   	
if (CLAMP == 0)
	{ // clamp way
	z = scale * clamp(z, -Csize, Csize) - (Zscale * z);
	}
else
	{ // other way
	if (z.x > Csize.x)  z.x = Csize.x  * 2.0f - ( Zscale.x * z.x);

	if (z.x < -Csize.x)
 z.x = -Csize.x * 2.0f - ( Zscale.x * z.x);
	if (z.y > Csize.y)
  z.y = Csize.y  * 2.0f - ( Zscale.y * z.y);
	if (z.y < -Csize.y)
 z.y = -Csize.y * 2.0f - ( Zscale.y * z.y);
	if (z.z > Csize.z)
  z.z = Csize.z  * 2.0f - ( Zscale.z * z.z);
	if (z.z < -Csize.z)
 z.z = -Csize.z * 2.0f - ( Zscale.z * z.z);
	}

float k = max(R2 / dot(z,z), 1.0f);
z *= k;
DE *= k + DEadd;
//example of use of rotation matrix (Mandelbox main rotation)
z = Matrix33MulFloat3(consts->fractal.mandelbox.mainRot, z);
z += cJ;
}
    
float rxy=length(z.xy);
	
	
if (rxy > colourMin) colourMin = rxy;
	
//needed for calculation of fake lights based on orbit traps
//#if _orbitTrapsEnabled
//if (i >= consts->fractal.fakeLightsMinIter && i <= consts->fractal.fakeLightsMaxIter) distFromOrbitTrap += (1.0f/(r*r));
//#endif
	
dist = max( rxy - 0.92784, fabs(rxy * z.z) / length(z)) / DE;
out.colourIndex = colourMin * 1000.0f;
break;
	
		